////////////////////////////////////////////////////////////////////////////////////////////////
//@Cook-TorranceVF[_[ۂ́@lF[J[
//		Ql	Maverick Project(http://maverickproj.web.fc2.com/pg00.html)
//			Project ASURA(http://asura.iaigiri.com/top.html)
//			Phong.fx(NVIDIA Shader Library)
//			full.fx(͉P)
//			advancedTexureMapping2(Furia)
//			DetailUp_for_Landscape(f[^P)
////////////////////////////////////////////////////////////////////////////////////////////////

// p[^錾

#include "config.h"

float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "sceneorobject";
	string ScriptOrder = "standard";
> = 0.8;

uniform float ShadowTH
<
   string UIName = "ShadowTH";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
   float UIStep = 0.01;
   string UIDefault = "0.30";
   string UIDescription = "e臒l";
> = float( 0.30 ); //̒lς

uniform float RimFactor
<
   string UIName = "RimFactor";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 2.00;
   float UIStep = 0.01;
   string UIDefault = "1.00";
   string UIDescription = "֊sӂ̃nCCg̋";
> = float( 1.50 ); //̒lς


// 𑝂₷ꍇ͂ǉĉiҏWӏ̓sNZVF[_ɂ܂j
// ʒu
const float3 LightPosition0 : CONTROLOBJECT < string name = "PointLight0.x";>;
const float3 LightPosition1 : CONTROLOBJECT < string name = "PointLight1.x";>;
const float3 LightPosition2 : CONTROLOBJECT < string name = "PointLight2.x";>;
const float3 LightPosition3 : CONTROLOBJECT < string name = "PointLight3.x";>;

// F
const float3 LightColor0 : CONTROLOBJECT < string name = "PointLight0.x"; string item = "Rxyz"; >;
const float3 LightColor1 : CONTROLOBJECT < string name = "PointLight1.x"; string item = "Rxyz"; >;
const float3 LightColor2 : CONTROLOBJECT < string name = "PointLight2.x"; string item = "Rxyz"; >;
const float3 LightColor3 : CONTROLOBJECT < string name = "PointLight3.x"; string item = "Rxyz"; >;

// ̖邳
const float LightPower0 : CONTROLOBJECT < string name = "PointLight0.x"; string item = "Si"; >;
const float LightPower1 : CONTROLOBJECT < string name = "PointLight1.x"; string item = "Si"; >;
const float LightPower2 : CONTROLOBJECT < string name = "PointLight2.x"; string item = "Si"; >;
const float LightPower3 : CONTROLOBJECT < string name = "PointLight3.x"; string item = "Si"; >;

// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float4x4 ViewProjMatrix           : VIEWPROJECTION;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
//float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   MaterialToon      : TOONCOLOR;

// CgF
//float3   LightDiffuse      : DIFFUSE   < string Object = "Light"; >;
float3   LightAmbient      : AMBIENT   < string Object = "Light"; >;
//float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 DiffuseColor  = min(MaterialDiffuse.rgb, float3(0.8,0.8,0.8))*LightAmbient/0.6;
static float4 AmbientColor  = float4( MaterialEmmisive*MaterialToon*LightAmbient, MaterialDiffuse.a+0.01);
//static float3 SpecularColor = MaterialSpecular * LightSpecular;

bool     parthf;   // p[XyNeButO
bool     transp;   // tO
//bool	 spadd;    // XtBA}bvZtO
#define SKII1    1500
#define SKII2    8000
#define Toon     3

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE<
	int MipLevels = 1;
	string Format = "A8R8G8B8" ;
>;

sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = ANISOTROPIC;
	MAGFILTER = ANISOTROPIC;
	MIPFILTER = LINEAR;
	MAXANISOTROPY = 16;
};

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

// VhEobt@
shared texture ShadowMap0 : OFFSCREENRENDERTARGET;
sampler ShadowMapSampler = sampler_state {
    texture = <ShadowMap0>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

///////////////////////////////////////////////////////////////////////////////////////////////
// eiZtVhEj`

// _VF[_
float4 Shadow_VS(float4 Pos : POSITION) : POSITION
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 Shadow_PS() : COLOR
{
    // ArGgFœhԂ
    return float4(AmbientColor.rgb, 0.65f);
}

// e`peNjbN
technique ShadowTec < string MMDPass = "shadow"; > {
    pass DrawShadow {
        VertexShader = compile vs_3_0 Shadow_VS();
        PixelShader  = compile ps_3_0 Shadow_PS();
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////
// ZtVhEpZlvbg
// ZlvbgpeNjbN
technique ZplotTec < string MMDPass = "zplot"; > {}
// RgAEgΕה邪Shift+GŃVhE}bv悤ɂȂB

////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MMDW̃ZtVhE̖邳vZ
float MMDShadowBrightness(float2 ShadowMapPos, float DepthRef){
	float shadow = max(DepthRef - tex2D(ShadowMapSampler,ShadowMapPos).r, 0);
	float comp = 1 - saturate(shadow*
		(parthf ? SKII2*ShadowMapPos.y // ZtVhE[h2
				: SKII1 // ZtVhE[h1
		)-0.3);
    return comp;
}

static const float2 sampstep = float2(1.0/SHADOWMAP_WIDTH, 1.0/SHADOWMAP_HEIGHT);

// ߂̃ZtVhE
// PCF 9_TvO
// 9_TvO
float GetZBufSample(float2 texc, float t, float steprate){
	float Out;
	float step = sampstep * steprate;

	Out = (t>tex2D(ShadowMapSampler, texc)) * 2;

	Out += (t>tex2D(ShadowMapSampler, texc + float2(0, step)));
	Out += (t>tex2D(ShadowMapSampler, texc + float2(0, -step)));
	Out += (t>tex2D(ShadowMapSampler, texc + float2(step, 0)));
	Out += (t>tex2D(ShadowMapSampler, texc + float2(-step, 0)));
	Out += (t>tex2D(ShadowMapSampler, texc + float2(step, step))) * 0.7071; // 0.7071=sqrt(0.5) S̋
	Out += (t>tex2D(ShadowMapSampler, texc + float2(-step, step))) * 0.7071;
	Out += (t>tex2D(ShadowMapSampler, texc + float2(step, -step))) * 0.7071;
	Out += (t>tex2D(ShadowMapSampler, texc + float2(-step, -step))) * 0.7071;

	Out /= 2 + 4 + 4*(0.7071);
	return Out;
}

float ShadowBrightness(float2 ShadowMapPos, float DepthRef){
	float comp;
	if(parthf && (ShadowMapPos.y<SOFTSHADOW_DISTANCE)){
		comp = MMDShadowBrightness(ShadowMapPos, DepthRef);
	}
	else{
		comp = 1-GetZBufSample(ShadowMapPos, DepthRef-SOFTSHADOW_THRESHOLD, 1);
	}
    return comp;
}

///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEONj

// VhEobt@̃TvB"register(s0)"Ȃ̂MMDs0gĂ邩
sampler DefSampler : register(s0);

struct BufferShadow_OUTPUT {
    float4 Pos      : POSITION;     // ˉeϊW
    float4 ZCalcTex : TEXCOORD0;    // Zl
    float2 Tex      : TEXCOORD1;    // eNX`
    float3 Normal   : TEXCOORD2;    // @
    float3 Eye      : TEXCOORD3;    // JƂ̑Έʒu
    float4 WPos     : TEXCOORD4;    // [hʒu
};

// _VF[_
BufferShadow_OUTPUT BufferShadow_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture)
{
    BufferShadow_OUTPUT Out = (BufferShadow_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    Out.Pos = mul( Pos, WorldViewProjMatrix );

    // [hʒu
    Out.WPos= mul( Pos, WorldMatrix ); 
    
    // JƂ̑Έʒu
    Out.Eye = CameraPosition - Out.WPos;

    // _@
    Out.Normal = mul( Normal, (float3x3)WorldMatrix );

    // Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul( Pos, LightWorldViewProjMatrix );
           
    // eNX`W
    Out.Tex = Tex;
    
    return Out;
}

// Beckmannz֐
inline float Beckmann(float m, float NH) {

    float NH2 = NH*NH;
    return exp(-(1-NH2)/(NH2*m*m))/(4*m*m*NH2*NH2);    

}

// gUˌƋʔˌ̌vZ
float3 LightVec(float3 L, float LightPower, float3 Nn, float3 Vn, float NV) {

    // ̌vZ
    float Distance = length(L);
    Distance *= Distance * 0.01 / LightPower; // xKp

    float3 Ln = normalize(L);
    float3 Hn = normalize(Vn + Ln);
    float  NL = dot(Nn,Ln);
    float  NH = dot(Nn, Hn);
    float  VH = dot(Vn, Hn);

    // CeBO(ǂƂĎg)
    float Rim = max( 0.0f, dot( Vn, -Ln ) )*(1.0f - max( 0.0f, NV ));

    // n[to[gŖ邳vZ
    float hlambert = NL*0.5f + 0.5;
    hlambert *= hlambert;

    // Beckmannz
    float D = Beckmann(MaterialSpecular.r, NH);

    // 􉽌
    float G = min( 1, min(2*NH*NV/VH, 2*NH*NL/VH) );

    // tl Schlick̋ߎH
    float F = lerp( MaterialSpecular.g, 1, pow(1-dot(Ln,Hn),5) );

    return float3( hlambert, max(0, F*D*G/NV), Rim )/Distance;

}

// sNZVF[_
float4 BufferShadow_PS(BufferShadow_OUTPUT IN, uniform bool useTexture) : COLOR
{

    float3 Nn = normalize(IN.Normal);
    float3 Vn = normalize(IN.Eye);
    float  NV = dot(Nn,Vn);

    // n[to[gŖ邳vZ
    float LdN = dot(Nn, -LightDirection);
    float hlambert = LdN*0.5f+0.5;
    hlambert *= hlambert;

    // CeBO
    float RimPowerT = max( 0.0f, dot( Vn, -LightDirection ));  // Cgx1
    float RimPowerH = max( 0.0f, dot( Vn, LightDirection ));   // Cgx2
    float Rim = 1.0f - max( 0.0f, NV );

    // ʍގ̗̖邳} 낢Ə
    float Rim2 = MaterialDiffuse.a >= 0.98f && MaterialDiffuse.a < 1.0f ? Rim+min(0,NV) : Rim; 

    // nCCgx   
    float RimHighlight = Rim2 * max((RimPowerT+RimPowerH), max(RimPowerT, (1-RimPowerH)));

    // Ƃɖ邳vZ
    // 𑝂₵ꍇ͂̌ł܂₵ĂOK
    // 4Ȃꍇ͕svȂ̂폜ΏyȂ邩
    float3 litV0 = LightVec(LightPosition0-IN.WPos, LightPower0, Nn, Vn, NV);
    float3 litV1 = LightVec(LightPosition1-IN.WPos, LightPower1, Nn, Vn, NV);
    float3 litV2 = LightVec(LightPosition2-IN.WPos, LightPower2, Nn, Vn, NV);
    float3 litV3 = LightVec(LightPosition3-IN.WPos, LightPower3, Nn, Vn, NV);
    
    // FKp
    // ςꍇ͂ύX
    float3 diffContribP = (litV0.x*LightColor0) + (litV1.x*LightColor1) + (litV2.x*LightColor2) + (litV3.x*LightColor3);
    float3 specContribP = (litV0.y*LightColor0) + (litV1.y*LightColor1) + (litV2.y*LightColor2) + (litV3.y*LightColor3);
    float3 rimContribP  = (litV0.z*LightColor0) + (litV1.z*LightColor1) + (litV2.z*LightColor2) + (litV3.z*LightColor3);

    // ގFKp
    float4 Color = float4((AmbientColor.rgb+rimContribP)*diffContribP + DiffuseColor.rgb, AmbientColor.a);

    // eNX`Kp   
    if ( useTexture ) {
        float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        Color *= TexColor;
    }

    // eNX`Wɕϊ
    IN.ZCalcTex /= IN.ZCalcTex.w;
    float2 ShadowMapPos;
    ShadowMapPos.x = (1.0 + IN.ZCalcTex.x)*0.5;
    ShadowMapPos.y = (1.0 - IN.ZCalcTex.y)*0.5;

    float comp = 1;
    if( !any( saturate(ShadowMapPos) != ShadowMapPos ) ) {
	comp = min(comp, ShadowBrightness(ShadowMapPos.xy, IN.ZCalcTex.z));
    }

    // e̋E:
    float ToonShadow = hlambert >= ShadowTH ? 1.0f : 0.0f;
    comp = min(ToonShadow,comp);

    // e̋E:MMDWɋ߂
    //float ToonShadow = hlambert + Rim2*RimPowerT >= ShadowTH ? 1.0f : 0.0f;
    //comp = min(max(0,LdN)*Toon, min(ToonShadow,comp));

    // e̐F ȂKȎ
    float4 ShadowColor = float4((1+Color.rgb)*Color.rgb*MaterialToon*0.5f, Color.a);

    float4 ans = lerp(ShadowColor , Color, comp);

    // e̓̕XyLZȂ
    ans.rgb += specContribP*MaterialSpecular.b*comp;

    if( transp ) ans.a = 0.5f;

    ans.rgb = max(ans.rgb, ans.rgb*RimHighlight*RimFactor); // nCCgZ

    return saturate(ans);
}

// IuWFNg`peNjbN
technique MainTecBS0  < string MMDPass = "object_ss"; bool UseTexture = false;> {
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(false);
        PixelShader  = compile ps_3_0 BufferShadow_PS(false);
    }
}

technique MainTecBS1  < string MMDPass = "object_ss"; bool UseTexture = true;> {
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(true);
        PixelShader  = compile ps_3_0 BufferShadow_PS(true);
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////